/*
** mpeg.h
** 
** Made by Arne Caspari
** Login   <arne@arne-laptop>
** 
** Started on  Tue Feb 27 07:23:18 2007 Arne Caspari
** Last update Mon Mar 19 07:49:47 2007 Arne Caspari
*/

#ifndef   	MPEG_H_
# define   	MPEG_H_

#include <stdio.h>
#include <stdlib.h>

#include <avcodec.h>
#include <avformat.h>
#include <semaphore.h>
#include <pthread.h>

#include "ucil.h"
#include "queue.h"
#include "unicap.h"
#include "../cpi/include/unicap_cpi.h"
#include "debug.h"

typedef struct PixelFormatFourccMap
{
      unsigned int fourcc;
      int pix_fmt;
} PixelFormatFourccMap;



/* struct PixelFormatFourccMap PixelFormatFourccs[] =  */
/* { */
/*    { UCIL_FOURCC( 'Y','U','Y','V' ), PIX_FMT_YUYV422 }, */
/*    { UCIL_FOURCC( 'R','G','B','3' ), PIX_FMT_RGB24 }, */
/*    { UCIL_FOURCC( 'R','G','B','4' ), PIX_FMT_RGB32 }, */
/*    { UCIL_FOURCC( 'U','Y','V','Y' ), PIX_FMT_UYVY422 }, */
/*    { UCIL_FOURCC( 'Y','8','0','0' ), PIX_FMT_GRAY8 }, */
/* }; */

/* static const int num_pix_fmt_fourccs =  sizeof( PixelFormatFourccs ) / sizeof( PixelFormatFourccMap ); */
extern PixelFormatFourccMap *PixelFormatFourccs;
extern const int ucil_NumPixelFormatFourccs;
extern int *PixelFormatBPP;
typedef struct _ucil_mpeg_video_file_object
{
      int fbuf_size;
      unsigned char *fbuf;
      FILE *f;
      AVCodecContext *ccontext;
      AVFrame *picture;
      int pix_fmt;
      
}ucil_mpeg_video_file_object_t;


typedef struct _ucil_mpeg_input_file_object
{
      AVFormatContext *pFormatCtx;   
      AVCodecContext *pCodecCtx;
      AVCodec *pCodec;
      AVFrame *pFrame;
      AVFrame *pOutFrame;
      AVPacket packet;
      uint8_t *raw_data;
      int bytes_remain;
      int video_stream;
      int out_pix_fmt;
      int in_pix_fmt;
      
      unicap_format_t format;

      sem_t sema;
      struct _unicap_queue *in_queue;
      sem_t                 in_sema;
      struct _unicap_queue *out_queue;
      volatile int          quit_capture_thread;
      pthread_t             worker_thread;

      unicap_event_callback_t event_callback;
      unicap_handle_t         event_unicap_handle;

      int frame_intervall;
      

} *ucil_mpeg_input_file_object_t;

ucil_mpeg_video_file_object_t *ucil_mpeg_create_video_file( const char *path, unicap_format_t *format, ...);
unicap_status_t ucil_mpeg_encode_frame( ucil_mpeg_video_file_object_t *vobj, unicap_data_buffer_t *buffer );
unicap_status_t ucil_mpeg_close_video_file( ucil_mpeg_video_file_object_t *vobj );
unicap_status_t ucil_mpeg_open_video_file( unicap_handle_t *unicap_handle, char *filename, unicap_format_t *format );

#endif 	    /* !MPEG_H_ */
