/* unicap
 *
 * Copyright (C) 2004 Arne Caspari ( arne_caspari@users.sourceforge.net )
 *
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __CS_XFM_H__
#define __CS_XFM_H__

#include <unicap.h>
#include <gdk/gdk.h>

#define YUY2 0x32595559//("YUY2") /* YUYV (packed, 16 bits) */
#define UYVY 0x59565955 /* UYVY (packed, 16 bits) */
#define Y411 0x31313459
#define RGB4 0x34424752
#define RGB3 0x33424752
#define GREY 0x59455247
#define Y800 0x30303859
#define Y420 0x30323459

size_t cs_xfm_get_image_data_size( unicap_format_t *format );
GdkPixbuf *cs_xfm_new_pixbuf( unicap_data_buffer_t *image_buffer, guchar *image_data );
GdkPixbuf *cs_xfm_new_allocated_pixbuf( unicap_data_buffer_t *image_buffer );
void cs_xfm_to_RGB24( unicap_data_buffer_t *data_buffer, guchar *dest );
void cs_xfm_to_RGB32( unicap_data_buffer_t *data_buffer, guchar *dest );

#endif //__CS_XFM_H__
